
Core - Feature # 60019

Status: Resolved Priority: Should have
Author: Sascha Egerer Category: File Abstraction Layer (FAL)
Created: 2014-07-01 Assigned To:
Updated: 2015-03-03 Due date:
PHP Version: 5.5
Complexity:
Sprint Focus: On Location Sprint
Subject: Create utility function to get the file mimetype depending on available php modules
Description

TYPO3 does currently use finfo_file to get the mime type of a file. This does only work if the finfo module is loaded in PHP.
dkd is currently working with Microsoft to get TYPO3 working in the Microsoft Azure Web Gallery and there is no finfo module installed
by default.

To get this code a little bit more portable there should be a wrapper function that checks if the finfo exsists and if not use 
mime_content_type.

Related issues:
duplicated by Core - Task # 46777: Improve behaviour when mime type detection... Closed 2013-03-29
precedes Core - Bug # 64929: Fix filesize Unittest on windows with CRLF Resolved 2015-02-08

Associated revisions
Revision e372399b - 2015-02-02 21:38 - Sascha Egerer 

[FEATURE] Add SplFileInfo implementation to get file mimeType

\TYPO3\CMS\Core\Type\File\FileInfo provides a new method
getMimeType() to get the MIME type of a file, e.g. text/html.

Custom implementations to determine the MIME type can be added
with the hook:

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS'][\TYPO3\CMS\Core\Type\File\FileInfo::class]['mimeTypeGuessers']

The FAL LocalDriver also uses this new API.

Resolves: #60019
References: #46777
Releases: master
Change-Id: Ia2fa95d2ef6452f8022e33f1b1d2a9336f3e0303
Reviewed-on: http://review.typo3.org/31256
Reviewed-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
Tested-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
Reviewed-by: Frans Saris <franssaris@gmail.com>
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>
Tested-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>
Tested-by: Steffen Müller <typo3@t3node.com>
History
#1 - 2014-07-01 10:18 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31256

#2 - 2014-07-01 10:29 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31256

#3 - 2014-07-26 12:54 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#4 - 2015-01-06 11:37 - Ingo Schmitt
- Category set to File Abstraction Layer (FAL)

#5 - 2015-01-29 11:48 - Sascha Egerer
- Target version set to next-patchlevel
- Sprint Focus set to On Location Sprint

#6 - 2015-02-01 00:25 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#7 - 2015-02-01 00:43 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#8 - 2015-02-01 00:47 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#9 - 2015-02-01 11:23 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#10 - 2015-02-01 12:41 - Gerrit Code Review
Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#11 - 2015-02-02 19:33 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31256

#12 - 2015-02-02 22:00 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:e372399b4bef5d76bbeeee1ec12e8f56c257e4b6.

#13 - 2015-02-08 14:22 - Stephan Großberndt
- Tracker changed from Bug to Feature

#14 - 2015-03-03 18:52 - Beltran Rueda

I could reproduce the following issue on Windows using 7.1.0 version:

PHP Fatal error:  Class 'finfo' not found in ...\typo3\sysext\core\Classes\Type\File\FileInfo.php on line 33

Replacing the following in the FileInfo.php file fixes the issue. Could you confirm this fix is correct?

if (!function_exists('finfo_file')) {

with:

if (function_exists('finfo_file')) {

#15 - 2015-03-03 19:04 - Wouter Wolters

Hi, this has been fixed meanwhile with https://review.typo3.org/#/c/37205/
